package com.bergerkiller.bukkit.nolagg.datapool;

import java.lang.ref.WeakReference;

public final class PoolBuffer <T> {
	public PoolBuffer(final Pool<T> pool, final T data, Object reference) {
		this.data = data;
		this.ref = new WeakReference<Object>(reference);
		this.pool = pool;
	}
	public boolean tryLoad(Object reference) {
		if (this.isFree()) {
			this.ref = new WeakReference<Object>(reference);
			return true;
		} else {
			return false;
		}
	}
	public boolean isFree() {
		return this.ref.get() == null;
	}
	public void setFree() {
		this.ref.clear();
		this.pool.setFree(this);
	}
	public T getData() {
		return this.data;
	}
	private WeakReference<Object> ref;
	private final T data;
	private final Pool<T> pool;
	protected int index;
}
